<?php

$no_http_headers = true;
include(dirname(__FILE__) . "/../include/config.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

$oids = array(
	"ifaddr" => ".1.3.6.1.4.1.6876.3.4.1.4",
	"netname" => ".1.3.6.1.4.1.6876.3.4.1.2",
	"pktstx" => ".1.3.6.1.4.1.6876.3.4.1.6",
	"kbtx" => ".1.3.6.1.4.1.6876.3.4.1.7",
	"vmid" => ".1.3.6.1.4.1.6876.2.1.1.7",
	"displayname" => ".1.3.6.1.4.1.6876.2.1.1.2",
	"netvmid" => ".1.3.6.1.4.1.6876.3.4.1.3",
	"index" => ".1.3.6.1.4.1.6876.3.4.1.1",
	"pktsrx" => ".1.3.6.1.4.1.6876.3.4.1.8",
	"kbrx" => ".1.3.6.1.4.1.6876.3.4.1.9"
        );

$hostname = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version = $_SERVER["argv"][3];
$cmd = $_SERVER["argv"][4];

if ($cmd == "index") {
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));
	
	for ($i=0;($i<sizeof($arr_index));$i++) {
		print $arr_index[$i] . "\n";
	}
}elseif ($cmd == "query") {
	$arg = $_SERVER["argv"][5];
	
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));

	if ($arg == "displayname") {
		$combination = array();
		$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", "", 161, 1000));
		$arr_vmindex = fooindex(cacti_snmp_walk($hostname, $snmp_community, $oids["vmid"], $snmp_version, "", "", 161, 1000));
		for ($i=0;($i<sizeof($arr));$i++) {
			$combination[$arr_vmindex[$i]] = $arr[$i];
		}
		$arr_netvmindex = fooindex(cacti_snmp_walk($hostname, $snmp_community, $oids["netvmid"], $snmp_version, "", "", 161, 1000));
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $combination[$arr_netvmindex[$i]] . "\n";
		}
	}elseif ($arg == "index") {
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
		}
	}elseif ($arg == "kbtx" || $arg == "kbrx" || $arg == "pktsrx" || $arg == "pktstx" || $arg == "ifaddr" || $arg == "netname") {
		$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", "", 161, 1000));
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr[$i] . "\n";
		}
	}
}elseif ($cmd == "get") {
	$arg = $_SERVER["argv"][5];
	$index = $_SERVER["argv"][6];
	
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));
	$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", "", 161, 1000));

	if (isset($arr_index[$index])) {
		print $arr[$index];
	}
}

function reindex($arr) {
	$return_arr = array();
	
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}
	
	return $return_arr;
}

function fooindex($arr) {
	$return_arr = array();
	for ($i=0;($i<sizeof($arr));$i++) {
		if (ereg("\.([0-9]+)$", $arr[$i]["oid"], $regs)) {
			$return_arr[$regs[1]] = $arr[$i]["value"];
		}
	}

	return $return_arr;
}

?>
