<?php

$no_http_headers = true;
include(dirname(__FILE__) . "/../include/config.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

$oids = array(
	"usage" => ".1.3.6.1.4.1.6876.3.1.2.1.3",
	"vmid" => ".1.3.6.1.4.1.6876.2.1.1.7",
	"displayname" => ".1.3.6.1.4.1.6876.2.1.1.2",
	"index" => ".1.3.6.1.4.1.6876.2.1.1.1",
	"vmstate" => ".1.3.6.1.4.1.6876.2.1.1.6",
	"gueststate" => ".1.3.6.1.4.1.6876.2.1.1.8"
        );

$hostname = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version = $_SERVER["argv"][3];
$cmd = $_SERVER["argv"][4];

if ($cmd == "index") {
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));
	
	for ($i=0;($i<sizeof($arr_index));$i++) {
		print $arr_index[$i] . "\n";
	}
}elseif ($cmd == "query") {
	$arg = $_SERVER["argv"][5];
	
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));

	if ($arg == "usage") {
		$arr = fooindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", "", 161, 1000));
		$arr_vmindex = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["vmid"], $snmp_version, "", "", 161, 1000));
		for ($i=0;($i<sizeof($arr_index));$i++) {
			if ($arr_vmindex[$i] == -1) {
				print $arr_index[$i] . "!U\n";
			}elseif (isset($arr[$arr_vmindex[$i]])) {
				print $arr_index[$i] . "!" . $arr[$arr_vmindex[$i]] . "\n";
			}
		}
	}elseif ($arg == "index") {
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
		}
	}elseif ($arg == "displayname" || $arg == "gueststate" || $arg == "vmstate") {
		$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", "", 161, 1000));
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr[$i] . "\n";
		}
	}
}elseif ($cmd == "get") {
	$arg = $_SERVER["argv"][5];
	$index = $_SERVER["argv"][6];
	
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", "", 161, 1000));
	$arr_vmindex = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["vmid"], $snmp_version, "", "", 161, 1000));
        $arr = fooindex(cacti_snmp_walk($hostname, $snmp_community, $oids["usage"], $snmp_version, "", "", 161, 1000));

	if (isset($arr_index[$index])) {
		if ($arr_vmindex[$index] == -1) {
			print "U";
		} elseif (isset($arr[$arr_vmindex[$index]])) {
			print $arr[$arr_vmindex[$index]];
		}
	}
}

function reindex($arr) {
	$return_arr = array();
	
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}
	
	return $return_arr;
}

function fooindex($arr) {
	$return_arr = array();
	for ($i=0;($i<sizeof($arr));$i++) {
		if (ereg("\.([0-9]+)$", $arr[$i]["oid"], $regs)) {
			$return_arr[$regs[1]] = $arr[$i]["value"];
		}
	}

	return $return_arr;
}

?>
